#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <syslog.h>
#include <errno.h>
#include "syserr.h"
#include "daemonize.h"

pid_t daemonize(char *argv0)
{
  pid_t pid;

  SYSERR(pid = fork());
  if (pid != 0)
    exit(0); /* parent should exit */

  /* child continues */

  SYSERR(pid = setsid()); /* become session leader */
  SYSERR(chdir("/")); /* make sure CWD won't be unmounted */
  umask(0); /* clear file creation mask */

  SYSERR(close(0)); /* close stdin, stdout, and stderr */
  SYSERR(close(1));
  SYSERR(close(2));

  openlog(basename(argv0), 0, LOG_DAEMON);
  SYSERR(atexit(closelog));

  return pid;
}
