#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include "syserr.h"

static void vmessage(const char *fmt, va_list args)
{
  struct stat stat_buf;

  if (fstat(STDERR_FILENO, &stat_buf) == 0 && isatty(STDERR_FILENO)) {
    vfprintf(stderr, fmt, args);
    fputc('\n', stderr);
  } else
    vsyslog(LOG_DAEMON | LOG_ERR, fmt, args);
}

void warning(const char *fmt, ...)
{
  va_list args;

  va_start(args, fmt);
  vmessage(fmt, args);
  va_end(args);
}

void error(const char *fmt, ...)
{
  va_list args;

  va_start(args, fmt);
  vmessage(fmt, args);
  va_end(args);
  exit(1);
}
