#ifndef SYSERR_H
#define SYSERR_H

#define SYSERR3(call, result, err)					\
  do {									\
    (err) = 0;								\
    if ((call) == (result))						\
      error("%s failed at line %d in file %s: %s\n",			\
	    #call, __LINE__, __FILE__, (err) ? strerror(err) : "");	\
  } while(0)

#define SYSERR2(call, result) SYSERR3(call, result, errno)
#define SYSERR(call) SYSERR2(call, -1)

void warning(const char *fmt, ...);
void error(const char *fmt, ...);

#endif
